<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "insurance_file".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "InsuranceFile".
 *
 * Columns in table "insurance_file" available as properties of the model,
 * followed by relations of table "insurance_file" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property string $file_name
 * @property string $s3_path
 * @property integer $count_success
 * @property integer $count_skipped
 * @property integer $count_error
 * @property integer $count_total
 * @property string $date_added
 * @property string $date_updated
 * @property string $status
 *
 * @property Account $account
 * @property InsuranceFileStats[] $insuranceFileStats
 */
abstract class BaseInsuranceFile extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'insurance_file';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'InsuranceFile|InsuranceFiles', $n);
    }

    public static function representingColumn()
    {
        return 'file_name';
    }

    public function rules()
    {
        return array(
            array('account_id, file_name, s3_path, date_added, status', 'required'),
            array('account_id, count_success, count_skipped, count_error, count_total', 'numerical', 'integerOnly'=>true),
            array('status', 'length', 'max'=>100),
            array('date_updated', 'safe'),
            array('count_success, count_skipped, count_error, count_total, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, file_name, s3_path, count_success, count_skipped, count_error, count_total, date_added, date_updated, status', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'insuranceFileStats' => array(self::HAS_MANY, 'InsuranceFileStats', 'insurance_file_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'file_name' => Yii::t('app', 'File Name'),
            's3_path' => Yii::t('app', 'S3 Path'),
            'count_success' => Yii::t('app', 'Count Success'),
            'count_skipped' => Yii::t('app', 'Count Skipped'),
            'count_error' => Yii::t('app', 'Count Error'),
            'count_total' => Yii::t('app', 'Count Total'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'status' => Yii::t('app', 'Status'),
            'account' => null,
            'insuranceFileStats' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('file_name', $this->file_name, true);
        $criteria->compare('s3_path', $this->s3_path, true);
        $criteria->compare('count_success', $this->count_success);
        $criteria->compare('count_skipped', $this->count_skipped);
        $criteria->compare('count_error', $this->count_error);
        $criteria->compare('count_total', $this->count_total);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('status', $this->status, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}